; Header File
; Created 12/03/2005; 11:57:34

display_string:
;d0.l #string  afficher
;d7.w valeur pour les erreurs
 movem.l a0-a2/d0-d2,-(a7)
 bclr.b  #15,d0
 beq     \skip_error_bit
 btst.b  #UTSR_ERRORS_ONLY_BIT,d7
 bne     \exit
\skip_error_bit:
 bsr     XR_stringPtr
 move.l  a0,a2
 btst.b  #UTSR_AUTHORIZE_SL_BIT,d7
 beq     \skip_status_line
 move.l  a0,-(a7)
 move.l  920(a5),a0
 jsr     (a0)
 addq.l  #4,a7
\skip_status_line:
 btst.b  #UTSR_AUTHORIZE_DLG_BIT,d7
 beq     \skip_dialog_box
 clr.l   -(a7)
 move.l  a0,-(a7)
 pea     program_str(pc)
 move.l  $1B4*4(a5),a0;DlgMessage 
 jsr     (a0)
 lea     12(a7),a7
\skip_dialog_box:
\exit:
 movem.l (a7)+,a0-a2/d0-d2
 rts


XR_stringPtr:
 movem.l d0-d3/a1,-(a7)
 moveq   #0,d3
 move.w  d0,d3
 move.l  d3,-(a7)
 move.l  $293*4(a5),a0;XR_stringPtr
 jsr     (a0)
 addq.l  #4,a7
 move.l  a0,d1
 bne     \exit
 lea     data_xr_string(pc),a0
 move.l  a0,a1
 move.w  (a1)+,d0
\loop:
 cmp.w   (a1)+,d3
 beq     \found
 addq.w  #2,a1
 dbra    d0,\loop
 lea     xr_string_not_found(pc),a0
 bra     \exit
\found:
 move.w  (a1),d3
 lea     0(a0,d3.l),a0
\exit:
 movem.l (a7)+,a1/d0-d3
 rts


data_xr_string:
 dc.w   3
 dc.w   $7000,cant_get_tsr_handle_str-data_xr_string
 dc.w   $7001,conflib_error_str-data_xr_string
 dc.w   $7002,already_installed_str-data_xr_string
 dc.w   $7003,success_str-data_xr_string
xr_string_not_found:
 dc.b   'XR_string not found',0
cant_get_tsr_handle_str:
 dc.b   'Error: Can''t get UTSR_HANDLE',0
conflib_error_str:
 dc.b   'Error in ConfLib',0
already_installed_str:
 dc.b   'Error: UTSR already installed',0
success_str:
 dc.b   'UTSR successfully installed',0
program_str:
 dc.b   'UTSR_Lib 0.4 beta',0
