; Header File
; Created 02/08/2004; 14:09:00


;*****************************************************************************************************************************
; utsrlib::install_tsr(const void * code, longint size, int num_func, const void * functions, ushort flags)
;******************************************************************************************************************************
;
;
;******************************************************************************************************************************


;flags pour autoriser les messages dans la SL / dialog box
;flags pour autoriser le TSR en plusieurs exemplaires
; vrifier les diffrents cas d'erreurs
;renvoyer le handle du TSR produit
;prciser dans la doc que le programme d'origine est chang
;

utsrlib@0000:
 movem.l a0-a6/d0-d7,-(a7)
 moveq   #0,d6
 move.l  200,a5
;d'abord on s'occupe du handle de la liste de tsr
 bsr     get_tsr_handle_init
 bsr     get_tsr_handle
 bne     \already_handle
 moveq   #6,d0
 bsr     alloc
 tst.w   d0
 beq     \exit_error_mem
 bsr     set_tsr_handle
 beq     \exit_conflib
 bsr     get_tsr_handle
 beq     \exit_cant_get_utsr_handle
 bsr     deref
 clr.w   (a0)
\already_handle:
;d'abord on recopie le code en RAM
;on prpare son handle, avec tout ce qu'il faut (nom...)
 lea     8*4+7*4+4(a7),a0
 move.l  (a0)+,a4;dbut du tsr
 move.l  (a0)+,d4;taille du tsr
 move.w  (a0)+,d5;nombre de fonctions
 move.l  (a0)+,a3;pointeur vers la table des fonctions
 move.w  (a0)+,d7;flags
 btst    #UTSR_AUTHORIZE_TWINS_BIT,d7
 bne     \skip_twins
 move.l  a4,-(a7)
 bsr     utsrlib@0002
 addq.l  #4,a7
 tst.w   d0
 bne     \error_already_installed
\skip_twins:
 move.l  d4,d0
 bsr     allochigh
 move.w  d0,d6
 beq     \error_memory;pas assez de mmoire :'(
 bsr     deref
 move.l  a0,a2
 move.l  d4,d0
 subq.l  #1,d0
 move.l  a4,a1
\copy:
 move.b  (a1)+,(a0)+
 dbra    d0,\copy
 move.w  d6,8(a2);UTSR_Id
;bon  ce niveau l on a recopi le tsr dans son bloc d6
;il ne reste plus qu' "brancher" toutes les "prises" dans la liste
 tst.w   d5
 beq     \error_erase
 subq.w  #1,d5
\loop_functions
;faudrait dj voir si cette fonction est rellement valide
;sinon on renvoie une erreur (pan dans sa gueule :D)
; move.w  (a3)+,d0;type de la fonction
; move.w  (a3)+,d2;offset de la fonction
;faudra penser  vrifier si le tsr tsrlib existe dj, sinon faut le rajouter
 bsr     get_handle_size
 add.b   (a3),d0
 add.w   #14,d0;je sais, a s'appelle tre flemmard :]

 move.l  d0,d1
 bsr     get_tsr_handle
 exg.l   d0,d1
 bsr     realloc

 tst.w   d0
 beq     \error_erase
 move.w  (a3),d0
 cmp.w   #UTSR_EV_HOOK,d0
 bgt     \skip_get_tsr_aux;on zappe la recherche d'un tsr auxilliaire, vu qu'il y en a pas besoin :)
 bsr     get_tsr_aux
 tst.w   d0
 bne     \skip_get_tsr_aux;le tsr auxilliaire correspondant est dj install
 move.w  (a3),d0
 bsr     install_tsr_aux
 tst.w   d0
 beq     \error_erase; on n'a pas russi  l'installer :'(
\skip_get_tsr_aux:
 bsr     get_end_handle
 move.w  d6,d0
 bsr     deref
 add.w   2(a3),a0;on calcule l'adresse absolue de la fonction
 add.l   #KERNEL_SPACE,a0
 move.l  a0,2(a1);on enregistre cette adresse dans la liste
 move.w  (a3),(a1);
 clr.w   6(a1);la liste doit se terminer par un UTSR_NULL
 cmp.w   #UTSR_UNKNOWN,(a3)
 bne     \skip_unknown
 addq.l  #4,a3
 move.l  (a3),a0;y a d'autres trucs  sauver dans la liste
 move.l  a0,6(a1)
 move.l  (a0),a0
 move.l  a0,10(a1)
 clr.w   14(a1);la liste doit se terminer par un UTSR_NULL
;faudra penser aux tsr inconnus, s'il y a besoin de les enregistrer dans le kernel ; par exemple avec une fonction write_vector %)
; move.l  4(a3),a0;on rcupre le vecteur
;a0 vecteur
; move.l  2(a1),d0;on rcupre l'adresse  mettre dans le vecteur
; bclr.b  #2,$600001
; move.l  d0,(a0);on met  jour le vecteur
; bset.b  #2,$600001
 move.l  (a3),d0;on rcupre le vecteur
;a0 vecteur
 move.l  2(a1),a0;on rcupre l'adresse  mettre dans le vecteur
 bsr     write_vector

 moveq   #-4,d0
 cmp.l   2700(a5),a0
 beq     \skip_known
 move.l  a0,d0
 cmp.l   #$80+15*4,a0
 bgt     \skip_unknown
\skip_known:
 move.l  2(a1),a0;il faut enregistrer tout a dans le kernel
 jsr     kernel::RegisterVector
\skip_unknown:
 addq.l  #4,a3
 dbra    d5,\loop_functions
 bsr     get_handle_size
 move.l  d0,d1
 bsr     get_tsr_handle
 exg.l   d0,d1
 bsr     realloc;pour supprimer la taille en trop :)
 move.w  #$7003,d0
 bsr     display_string
\exit:
 move.w  d6,d0
 beq     \skip_keep_handle
 jsr     kernel::HdKeep
\skip_keep_handle: 
 bsr     register_all_vectors
 movem.l (a7)+,a0-a6/d0-d7
 rts
\error_memory:
;faire un code d'erreur
;+ message dans la SL
 move.w  #$85BA,d0
 bra     \exit_display_error
\error_erase:
;l il faut effacer le bloc dj cr
 move.w  d6,d0
 bsr     free
 bra     \exit
\exit_cant_get_utsr_handle:
 move.w  #$F000,d0
\exit_display_error:
 bsr     display_string
 bra     \exit
\exit_conflib:
 move.w  #$F001,d0
 bra     \exit_display_error
\exit_error_mem:
 move.w  #$85BA,d0
 bra     \exit_display_error
\error_already_installed:
 move.w  #$F002,d0
 bra     \exit_display_error





get_tsr_aux:
;<- d0. fonction dont on cherche le tsr aux
;-> d0 = 0 si non trouv
;-> sinon, on a d0.l = l'adresse du tsr aux
 movem.l d1-d2/a0,-(a7)
 bsr     get_adress
 move.l  a0,d2
 bsr     get_tsr_handle
 bsr     deref
 moveq   #0,d0
 moveq   #0,d1
\loop:
 tst.w   (a0)
 beq     \exit
 cmp.w   #UTSR_TSRLIB,(a0)
 bne     \skip
 move.l  a0,d0
 cmp.l   6(a0),d2
 beq     \exit
 moveq   #0,d0
\skip:
 move.b  (a0),d1
 adda.w  d1,a0
 bra     \loop
\exit: 
 movem.l (a7)+,d1-d2/a0
 rts
install_tsr_aux:
;<- d0. fonction dont on veut installer le tsr aux
;-> d0.w = 0 chec
 movem.l d1-d7/a0-a4,-(a7)
 move.w  d0,d4
 bsr     get_tsr_aux
 tst.w   d0;il est dj install #triso#
 bne     \exit
 movea.l tios::Heap,a2
 bsr     get_tsr_handle
 lsl.w   #2,d0
 adda.w  d0,a2
 cmp.w   #UTSR_EV_HOOK,d4
 beq     \ev_hook
\interrupt:
 lea     UTSR_INTERRUPT_reloc1(pc),a0
 move.w  d4,2(a0);on spcialise le TSR superviseur
 lea     UTSR_INTERRUPT_reloc3(pc),a0
 lea     UTSR_INTERRUPT_BEGINNING(pc),a1
 move.w  #UTSR_INTERRUPT_END-UTSR_INTERRUPT_BEGINNING,d0
 lea     UTSR_INTERRUPT_reloc2(pc),a3
 moveq   #$0,d5
 bra     \common
\ev_hook:
 lea     UTSR_HOOK_reloc1(pc),a0
 lea     UTSR_HOOK_old_event(pc),a3
 lea     UTSR_HOOK_BEGINNING(pc),a1
 move.w  #UTSR_HOOK_END-UTSR_HOOK_BEGINNING,d0
 moveq   #$10,d5
\common:
 move.l  a2,(a0)
 move.l  d0,d3
 move.w  d4,d0
 bsr     get_adress
 move.l  (a0),(a3)
 move.l  (a0),d7
 move.l  d3,d0
 bsr     allochigh_keep
 move.w  d0,d6
 beq     \exit
 bsr     deref
 lea     0(a0,d5.w),a2
 add.l   #KERNEL_SPACE,a2
 subq.w  #1,d3
\loop:
 move.b  (a1)+,(a0)+
 dbra    d3,\loop
 move.w  #$2700,-(a7)
 move.l  2672(a5),a3;OSSetSR
 jsr     (a3)
 move.w  d0,(a7)
 bclr.b  #2,$600001

 move.w  d4,d0
 bsr     get_adress
 move.l  a2,(a0)

 bset.b  #2,$600001
 jsr     (a3)
 addq.l  #2,a7
 move.w  d6,d0
;bon bah maintenant faut le linker dans la liste
 bsr     get_end_handle
 move.w  d4,d0
 bsr     get_adress
 move.w  #UTSR_TSRLIB,(a1)+
 move.l  a2,(a1)+
 move.l  a0,(a1)+
 move.l  d7,(a1)+
 clr.w   (a1)+
;et maintenant faut l'enregistrer dans le kernel
 move.l  a0,d0
 move.l  a2,a0
 cmp.w   #UTSR_EV_HOOK,d4
 bne     \skip
 moveq   #-4,d0
\skip
 jsr     kernel::RegisterVector
 moveq   #1,d0
\exit:
 movem.l (a7)+,d1-d7/a0-a4
 rts
 
get_end_handle:
;-> a1.l pointeur vers la fin de la liste, juste avant le UTSR_NULL
 movem.l d0/a0,-(a7)
 bsr     get_tsr_handle
 bsr     deref
 bsr     get_handle_size
 adda.w  d0,a0
 move.l  a0,a1
 subq.l  #2,a1
 movem.l (a7)+,a0/d0
 rts
get_adress:
;<- d0 fonction  chercher
;-> a0.l adresse du vecteur correspondant
 moveq   #0,d1
 andi.w  #$FF,d0
 cmp.w   #UTSR_NULL,d0
 ble     \exit
 move.w  d0,d1
 lsl.w   #2,d1
 add.w   #$60,d1
 cmp.w   #UTSR_AUTOINT_7-$600,d0
 ble     \exit
 sub.w   #$20,d1
 cmp.w   #UTSR_TRAP_15-$600,d0
 ble     \exit
 move.l  2700(a5),d1;EV_Hook
 cmp.w   #UTSR_EV_HOOK-$600,d0
 ble     \exit
 moveq   #0,d1
\exit:
 move.l  d1,a0
 rts
get_handle_size:
;-> d0.l taille thorique de la liste
 movem.l a0/d1,-(a7)
 bsr     get_tsr_handle
 bsr     deref
 moveq   #2,d0
 moveq   #0,d1
\loop:
 tst.w   (a0)
 beq     \exit
 move.b  (a0),d1
 adda.w  d1,a0
 add.w   d1,d0
 bra     \loop
\exit:
 movem.l (a7)+,a0/d1
 rts
 
 include "superviseurs.h"
